/************************************************************************
gif4web.c  v 0.03 alpha 2.11.08
please report any bug to: klee@unibwm.de
*************************************************************************
external functions used:  getc(); putc(); fopen(); fclose();
*************************************************************************
should compile with any C compiler with int >= 32 bit
************************************************************************/
/*
v 0.01 24.7.97
v 0.01 29.7.97 renamed to gif4web (there is already a webgif program for amiga)
v 0.02 31.7.97 generate control file when decoding (for easy re-encoding)
v 0.03 2.11.08 support gif without global colortable
*/
 
#include <stdio.h>

#ifndef NULL
#define NULL 0
#endif 

#define max_string 256

FILE *ctr, *gif, *tmp, *fopen(), *fopenb();
char buf[max_string+5];
char colortab[256*3];

int sizex, sizey, background, ratio;
int posx,posy,global_flags,image_flags,ctrl_flags,delay,trans,localcolor,clang;

int ctr_eof=0;
int line_nr=1;

/***********************************************************************/

main(nargs,args) int nargs; char *args[];
{if (nargs==3) encode(nargs,args);
 else if (nargs==2) decode(nargs,args);
 else ende(1,1);
 ende(2,0);
}

/***********************************************************************/

encode(nargs,args) int nargs; char *args[];
{int i,j,k;
 ctr = fopen(args[1],"r");  if (ctr==NULL) ende(3,2); 
 gif = fopen(args[2],"wb"); if (gif==NULL) ende(4,3);

 get_string(buf); tmp = fopen(buf,"rb"); if (tmp==NULL) ende(5,4);
 if (getc(tmp)!='G') ende(6,5);
 if (getc(tmp)!='I') ende(7,5);
 if (getc(tmp)!='F') ende(8,5);
 getc(tmp); getc(tmp); getc(tmp);
 out_string("GIF89a");

 /* copy global color table */
 sizex=getc(tmp)+(getc(tmp)<<8);
 i=get_dec(); if (i<=0) out_word(sizex); else out_word(i);
 sizey=getc(tmp)+(getc(tmp)<<8);
 i=get_dec(); if (i<=0) out_word(sizey); else out_word(i);

 /* ver 0.02
 j=getc(tmp); if (!(j&0x80)) ende(9,6); out_byte(j);
 background=getc(tmp);
 i=get_dec(); if (i<0) out_byte(background); else out_byte(i);
 ratio=getc(tmp);
 i=get_dec(); if (i<0) out_byte(ratio); else out_byte(i);
 j = (1<<((j&7)+1))*3; while (j--) out_byte(getc(tmp));
 */
 
 /* ver 0.03 */
 j=getc(tmp); out_byte(j);
 background=getc(tmp);
 i=get_dec(); if (i<0) out_byte(background); else out_byte(i);
 ratio=getc(tmp);
 i=get_dec(); if (i<0) out_byte(ratio); else out_byte(i);
 if (j&0x80) {j = (1<<((j&7)+1))*3; while (j--) out_byte(getc(tmp));}
 /* end ver 0.03 */

 fclose(tmp);

 /* output application extention: netscape loop */
 out_text(16,"\41\377\13NETSCAPE2.0\3\1");
 out_word(get_dec()); out_byte(0);

 while (1)
  {get_string(buf); if (ctr_eof) break; 
   posx=get_dec(); posy=get_dec(); localcolor=get_dec();
   ctrl_flags=((get_dec()&7)<<2)+((get_dec()&1)<<1);
   delay=get_dec();
   if ((trans=get_dec())>=0) ctrl_flags++;

   tmp = fopen(buf,"rb"); if (tmp==NULL) ende(10,4);
   if (getc(tmp)!='G') ende(11,5);
   if (getc(tmp)!='I') ende(12,5);
   if (getc(tmp)!='F') ende(13,5);
   for (i=0; i<7; i++) getc(tmp);
   global_flags=getc(tmp); if (!(global_flags&0x80)) ende(14,6); 
   image_flags = ((global_flags&0x08)<<2)+(global_flags&0x87);
   clang = (1<<((global_flags&7)+1))*3; 
   getc(tmp); getc(tmp);
   for (i=0; i<clang; i++) colortab[i]=getc(tmp);

   while ( (i=getc(tmp))== 0x21)
     {if (getc(tmp)==0xf9)
         {if (getc(tmp)!=4) ende(15,5);
          i=getc(tmp); getc(tmp); getc(tmp); j=getc(tmp); getc(tmp);
          if ( (trans == -1) && (i&1) ) {ctrl_flags=ctrl_flags|1; trans=j;}
         }
      else while (i=getc(tmp)) for (j=0; j<i; j++) getc(tmp);
     }

   if (i!=0x2c) ende(16,8);
   if (trans<0) trans=0;
   out_byte(0x21); out_byte(0xf9); out_byte(0x4);
   out_byte(ctrl_flags); out_word(delay); out_byte(trans); out_byte(0);
   out_byte(0x2c);
   getc(tmp); getc(tmp); getc(tmp); getc(tmp); 
   out_word(posx); out_word(posy);
   for (i=0; i<4; i++) out_byte(getc(tmp));
   i=getc(tmp);

   if (i&0x80) {image_flags=i;
                clang = (1<<((i&7)+1))*3; 
                for (j=0; j<clang; j++) colortab[j]=getc(tmp);
               }
   i=i&0x58; if (localcolor) i=i|image_flags; out_byte(i);

   if (localcolor) for (i=0; i<clang; i++) out_byte(colortab[i]);
   out_byte(getc(tmp));
   while (i=getc(tmp))
      {out_byte(i); for (j=0; j<i; j++) out_byte(getc(tmp));}
   out_byte(0); 
   fclose(tmp);
  }
 /* ver 0.02  
 out_text(76,"\41\376\110\nmade by gif4web (ftp://mistress.\
informatik.unibw-muenchen.de/pub/gif/)\n\0");
 */

 /* ver 0.03 */ 
 /*       n , 0x21,0xfe,n-4, n-4 byte string, 0x00 */
 out_text(53,
  "\41\376\61\nmade by gif4web (http://www.bitlib.de/pub/gif/)\n\0");
 /* end ver 0.03 */ 

 out_byte(0x3b);
 fclose(ctr);
 fclose(gif);
}

/***********************************************************************/

decode(nargs,args) int nargs; char *args[];
{int i,j,k;
 char *filename="_001_.gif";
 char *ctrext="\41\371\4\0\0\0\0";
 int ctrext_flag=0;
 
 gif = fopen("_000_.gif","wb"); if (gif==NULL) ende(25,3);
 ctr = fopen("_000_.ctr","w"); if (ctr==NULL) ende(17,3);
 ctr_string(";filename   sizex   sizey  background ratio");
 ctr_string(" loopcount\n_000_.gif");
 tmp = fopen(args[1],"rb"); if (tmp==NULL) ende(17,4);
 if (getc(tmp)!='G') ende(18,5);
 if (getc(tmp)!='I') ende(19,5);
 if (getc(tmp)!='F') ende(20,5);
 out_string("GIF");
 for (i=0; i<3; i++) out_byte(getc(tmp));

 out_byte(i=getc(tmp)); out_byte(j=getc(tmp)); ctr_dec((j<<8)+i);
 out_byte(i=getc(tmp)); out_byte(j=getc(tmp)); ctr_dec((j<<8)+i);

 /* ver 0.02 
 out_byte(global_flags=getc(tmp)); if (!(global_flags&0x80)) ende(21,6); 
 
 clang = (1<<((global_flags&7)+1))*3; 
 out_byte(background=getc(tmp)); ctr_dec(background);
 out_byte(ratio=getc(tmp)); ctr_dec(ratio); ctr_dec(0);
 for (i=0; i<clang; i++) out_byte(colortab[i]=getc(tmp));
 */

 /* ver 0.03 */
 out_byte(global_flags=getc(tmp)); 
 out_byte(background=getc(tmp)); ctr_dec(background);
 out_byte(ratio=getc(tmp)); ctr_dec(ratio); ctr_dec(0);

 if (global_flags&0x80)
  {clang = (1<<((global_flags&7)+1))*3; 
   for (i=0; i<clang; i++) out_byte(colortab[i]=getc(tmp));
  }
 /* end ver 0.03 */

 out_byte(0x3b); fclose(gif);
 ctr_string("\n;filename    posx    posy localcolor ");
 ctr_string("disposal input   delay transpar\n");

 while ( (i=getc(tmp)) != 0x3b )
   {if (i==EOF) ende(22,10);
    else if (i==0x21)
     {if (getc(tmp)==0xf9)
         {if (getc(tmp)!=4) ende(23,5);
          if (ctrext[3]=(ctrl_flags=getc(tmp))&1) ctrext_flag=1;
          delay=getc(tmp) + (getc(tmp)<<8); 
          ctrext[6]=trans=getc(tmp); getc(tmp);
         }
      else while (i=getc(tmp)) {if (i==EOF) ende(24,10);
                                for (j=0; j<i; j++) getc(tmp);
                               }
     }
    else if (i==0x2c)
     {
      posx =getc(tmp)+(getc(tmp)<<8);
      posy =getc(tmp)+(getc(tmp)<<8);
      sizex=getc(tmp)+(getc(tmp)<<8);
      sizey=getc(tmp)+(getc(tmp)<<8);
      image_flags=getc(tmp);

      ctr_string(filename); ctr_dec(posx); ctr_dec(posy);
      ctr_dec(image_flags>>7); 
      ctr_dec((ctrl_flags>>2)&7); ctr_dec((ctrl_flags>>1)&1);
      ctr_dec(delay); 
      if (ctrext_flag) ctr_dec(trans); else ctr_dec(-1); ctr_byte('\n');
      
      gif = fopen(filename,"wb"); if (gif==NULL) ende(25,3);
      out_string("GIF89a");
      out_word(sizex); 
      out_word(sizey);
      if (image_flags&0x80)
         {i = (image_flags&0x87) + ((image_flags&0x07)<<4) 
              + ((image_flags&0x20)>>2);
          out_byte(i); out_byte(background); out_byte(ratio);
          i = (1<<((i&7)+1))*3; 
          for (j=0; j<i; j++) out_byte(getc(tmp));
         }
      else
         {out_byte(global_flags); out_byte(background); out_byte(ratio);
          for (i=0; i<clang; i++) out_byte(colortab[i]);
         }
      if (ctrext_flag) {ctrext_flag=0; out_text(8,ctrext);}
      out_text(5,"\54\0\0\0\0");
      out_word(sizex);      
      out_word(sizey);
      out_byte(image_flags&0x40);
      out_byte(getc(tmp));
      while (i=getc(tmp))
         {if (i==EOF) ende(26,10);
          out_byte(i); for (j=0; j<i; j++) out_byte(getc(tmp));}
      out_byte(0); 
      out_byte(0x3b);
      fclose(gif);
      filename[3]++; 
      if (filename[3]>'9') 
         {filename[3]='0'; 
          filename[2]++;
          if (filename[2]>'9') 
             {filename[2]='0'; 
              filename[1]++;
              if (filename[1]>'9') ende(27,7); 
             } 
         }
     }
    else ende(28,8);
   }
 fclose(tmp);
}


/***********************************************************************/
/***********************************************************************/
/***********************************************************************/

int get_byte() 
{int i;
 if ((i=getc(ctr)) == '\n') line_nr++;
 else if (i==';') {while ((i=getc(ctr))!='\n' && i!=EOF); line_nr++;}
 if (i==EOF) ctr_eof=1;
 if (i<' ') i=' ';
 return(i);
}

/***********************************************************************/

int get_string(p) char *p;
{int i,j=0;
 while((i=get_byte())<=' ') if (ctr_eof) {*p=0; return(0);}
 while ( i > ' ')
   {*p++=i; if (j++ >=max_string) ende(29,9); i=get_byte();}
 *p=0; return(0);
} 
/***********************************************************************/

int get_dec()
{int i,j=0,k=1;
 while((i=get_byte())<=' ') if (ctr_eof)  ende(30,10);
 if (i=='-') {k=-1; i=get_byte();}
 while (i>' ')
   {if ( i<'0' || i>'9') ende(31,11); j=j*10+i-'0'; i=get_byte();}
 return(k*j);
} 

/***********************************************************************/

int out_string(p) char *p; {while (*p) out_byte(*p++);}
int out_text(n,p) int n; char *p; {while (n--) out_byte(*p++);}
int out_dec(i)    int i; {int k,j=1; if (i<0) {out_byte('-'); i = -i;}
                  k=i; while (k /= 10) j *= 10; while (j) {k=i/j;
                  out_byte(k+'0'); i -= k*j; j /= 10;}}
int out_byte(i)   int i; {putc(i,gif);}
int out_word(i)   int i; {putc(i,gif);putc(i>>8,gif);}

/***********************************************************************/

int ctr_string(p) char *p; {while (*p) ctr_byte(*p++);}
int ctr_dec(i)    int i; {int k,j=1; if (i) ctr_byte(' '); 
                  k=100000; while (k>i && k>(-i)){ctr_byte(' '); k/=10;}
                  if (i<0) {ctr_byte('-'); i = -i;} else ctr_byte(' ');
                  k=i; while (k /= 10) j *= 10; while (j) {k=i/j;
                  ctr_byte(k+'0'); i -= k*j; j /= 10;}}
int ctr_byte(i)   int i; {putc(i,ctr);}

/***********************************************************************/

int cmpstr(p,q) char *p,*q;
{int i;
 do {if (*p != *q++) return(0);} while (*p++);
 return(1);
} 

int put_string(p,q) char *p,**q; 
    {while (*p) *(*q)++ = *p++; *(*q) =0;}

int put_dec(i,q) int i; char **q;
    {int k,j=1; 
     if (i<0) {*(*q)++ = '-'; i = -i;}
     k=i; 
     while (k /= 10) j *= 10; 
     while (j) {k=i/j; *(*q)++ = k+'0'; i -= k*j; j /= 10;}
     *(*q) =0;
    }

/***********************************************************************/
 
/***********************************************************************/

int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {

/*  0 */ "no errors" ,
/*  1 */ "\nusage: gif4web control_file outfile\n   or: gif4web infile" ,
/*  2 */ "can't open control file" ,
/*  3 */ "can't open output file" ,
/*  4 */ "can't open input file" ,
/*  5 */ "file is not in gif format" ,
/*  6 */ "no global color table" ,
/*  7 */ "to much pictures" ,
/*  8 */ "unknown gif tag" ,
/*  9 */ "string to long" ,
/* 10 */ "unexpected end of input file" ,
/* 11 */ "error reading number" ,
/* 12 */ "you never should read this" ,
/* 13 */ "you never should read this" ,
};
 print_string("\n"); 
 if (i) {print_string("error in line "); print_dec(line_nr); 
         print_string(" ("); print_dec(j); print_string(")  ");}
 print_string(meld[i]); print_string("\n");
   
 if (ctr!=NULL) fclose(ctr);
 if (gif!=NULL) fclose(gif);
 exit(0);
}

/***********************************************************************/

int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}

/***********************************************************************/

int print_string(p) char *p;
{while (*p) putc(*p++,stdout);}

/***********************************************************************/


